<template>
    <div
       
        class="page-container"
    >
        <ValidationObserver
            ref="obs"
        >
            <div class="edit__top"> 
                <Tabs
                    ref="tabs"
                    :items="reminders"
                    @switch="tabIndex = $event"
                />
                <div
                    v-if="reminders"
                    class="edit__actions"
                >
                    <template
                        v-for="(item, index) in reminders"
                    >
                        <ToggleButton
                            v-if="index === tabIndex"
                            :key="index"
                            v-model="item.status"
                            :font-size="12"
                            class="toggle-btn"
                            :height="24"
                            :labels="true"
                            color="rgb(45, 119, 245)"
                            @change="changeStatus(reminders[tabIndex].id, reminders[tabIndex].status)"
                        />
                    </template>
                    <div>
                        <button
                            type="button"
                            class="btn blue-btn"
                            @click="saveReminders"
                        >
                            Save
                        </button>
                    </div>
                </div>
            </div>
            <div
                v-if="reminders"
                class="row"
            >
                <PushReminder
                    class="col-12 col-xl-6"
                    :text-editor="reminders[tabIndex]"
                />
                <div class="col-12 col-xl-6 edit__preview">
                    <PushPreview :push-preview="reminders[tabIndex]" />
                </div>
            </div>
        </ValidationObserver>
    </div>
</template>

<script>
import pushReminders from "@/mixins/push/abandoned-carts.service";
import PushReminder from "@/components/push/abandoned-carts/PushReminder";
import PushPreview from "@/components/push/abandoned-carts/PushPreview";
import Tabs from '@/components/elements/Tabs'
export default {
    name: "Edit",
    components: {PushPreview, PushReminder, Tabs},
    mixins: [pushReminders],
    data() {
        return {
            reminders: null,
            helpModalId: 'HelpModalSMSAbandoned',
            data: null,
            tabIndex: null,
        }
    },
    async created() {
       await this.getReminders();       
    },
    mounted() {
        this.tabIndex = parseInt(this.$route.params.id) - 1
        this.$refs.tabs.updTab(this.tabIndex)
    },
    methods: {
        titleTab(order) {
            if (order == 1){
                return  order + 'st Reminder'
            } else if (order == 2) {
                return  order + 'nd Reminder'
            } else if (order == 3) {
                return  order + 'rd Reminder'
            } else  {
                return  order + 'th Reminder'
            }
        },
        async changeStatus(id, status) {
            await this.status(id, status)
            try {
                this.$notify({
                    type: 'success',
                    title: 'Status Changed'
                })
            } catch (error) {
                console.log(error)
            }
        },
        async getReminders() {
            const { reminders } = await this.getPushAbandonedCarts()

            this.reminders = reminders.map((el, index) => ({
                tabTitle: this.titleTab(index+1),
                ...el, 
            }))
        },
        async saveReminders() {
            const result = await this.$refs.obs.validate();
            let valid = await this.$refs.obs
            if (result) {
                await this.save({reminders: this.reminders})
                this.$notify({
                    type: 'success',
                    title: 'Saved'
                });
                setTimeout(() => {
                    this.$refs.obs.reset()
                }, 2000)
                // this.$router.push('/push/abandoned-carts')
            } else  this.getFormErrors(valid.errors)

        }
    }
}
</script>

<style lang="scss" scoped>

.btn {
    margin-right: 4px;
}

.sms-tab-container {
    margin-top: 20px;
}


.action-container {
    float: right;
    width: max-content;
    display: flex;
    align-items: center;
    justify-content: flex-end;
    margin-top: -62px;
    @media screen and (max-width: 1200px) {
        display: none !important;
    }
}
.edit__top {
    margin-top: 25px;
}

</style>
